Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class SlashExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.SlashExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, ContextMappingFunction<Item>, ContextSwitchingExpression, InstructionInfo, Locator

Direct Known Subclasses:
  SimpleStepExpression

    public class SlashExpression

extends Expression
implements ContextSwitchingExpression, ContextMappingFunction<Item>

A slash expression is any expression using the binary slash operator "/". The parser initially generates a slash expression for all occurrences of the binary "/" operator. Subsequently, as a result of type inferencing, the majority of slash expressions will be rewritten as instances of PathExpression (returning nodes) or ForEach instructions (when they return atomic values). However, in the rare case where it is not possible to determine statically whether the rh operand returns nodes or atomic values, instances of this class may need to be interpreted directly at run time.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`SlashExpression(Expression start, Expression step)` Constructor

Method Summary
`PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
`int` | `computeCardinality()` Determine the static cardinality of the expression
`int` | `computeDependencies()` Determine which aspects of the context the expression depends on.
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`Expression` | `copy()` Copy an expression.
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`void` | `explain(ExpressionPresenter destination)` Diagnostic print of expression structure.
`Expression` | `getControlledExpression()` Get the step expression (the right-hand operand)
`Expression` | `getControllingExpression()` Get the start expression (the left-hand operand)
`Expression` | `getFirstStep()` Get the first step in this expression.
`IntegerValue[]` | `getIntegerBounds()` For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by this exprssion
`Expression` | `getLastStep()` Get the last step of the path expression
`Expression` | `getLeadingSteps()` Get a path expression consisting of all steps except the last
`Expression` | `getRemainingSteps()` Get all steps after the first.
`Expression` | `getStep()` Get step of the path expression
`int` | `hashCode()` get HashCode for comparing two expressions
`boolean` | `hasLoopingSubexpression(Expression child)` Given an expression that is an immediate child of this expression, test whether the evaluation of the parent expression causes the child expression to be evaluated repeatedly
`boolean` | `isAbsolute(TypeHierarchy th)` Test whether a path expression is an absolute path - that is, a path whose first step selects a document node
`SequenceIterator<? extends Item>` | `iterate(XPathContext context)` Iterate the path-expression in a given context
`Iterator<Expression>` | `iterateSameFocusSubExpressions()` Get the immediate sub-expressions of this expression that are evaluated with the same focus (context item, position, and size) as the parent expression.
`Iterator<Expression>` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`SequenceIterator` | `map(XPathContext context)` Mapping function, from a node returned by the start iteration, to a sequence returned by the child.
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `promote(PromotionOffer offer, Expression parent)` Promote this expression if possible
`protected Expression` | `promoteFocusIndependentSubexpressions(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` If any subexpressions within the step are not dependent on the focus, and if they are not "creative" expressions (expressions that can create new nodes), then promote them: this causes them to be evaluated once, outside the path expression
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` | `setStartExpression(Expression start2)`
`void` | `setStepExpression(Expression step2)`
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression
`String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`SlashExpression` | `tryToMakeAbsolute(TypeHierarchy th)` Test whether a path expression is an absolute path - that is, a path whose first step selects a document node; if not, see if it can be converted to an absolute path.
`Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SlashExpression

    public SlashExpression(Expression start,
                           Expression step)

  Constructor

  Parameters:
    `start` - The left hand operand (which must always select a sequence of nodes).
    `step` - The step to be followed from each node in the start expression to yield a new sequence; this may return either nodes or atomic values (but not a mixture of the two)

Method Detail

### setStartExpression

    public void setStartExpression(Expression start2)

### setStepExpression

    public void setStepExpression(Expression step2)

### getControllingExpression

    public Expression getControllingExpression()

  Get the start expression (the left-hand operand)

  Specified by:
    `getControllingExpression` in interface `ContextSwitchingExpression`
  Returns:
    the first operand

### getControlledExpression

    public Expression getControlledExpression()

  Get the step expression (the right-hand operand)

  Specified by:
    `getControlledExpression` in interface `ContextSwitchingExpression`
  Returns:
    the second operand

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Parameters:
    `visitor` - the expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### getItemType

    public final ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by this exprssion

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the type of the step

### getIntegerBounds

    public IntegerValue[] getIntegerBounds()

  For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.

  Overrides:
    `getIntegerBounds` in class `Expression`
  Returns:
    the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ExpressionVisitor.ContextItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### tryToMakeAbsolute

    public SlashExpression tryToMakeAbsolute(TypeHierarchy th)

  Test whether a path expression is an absolute path - that is, a path whose first step selects a document node; if not, see if it can be converted to an absolute path. This is possible in cases where the path expression has the form a/b/c and it is known that the context item is a document node; in this case it is safe to change the path expression to /a/b/c

  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the path expression if it is absolute; the converted path expression if it can be made absolute; or null if neither condition applies.

### promoteFocusIndependentSubexpressions

    protected Expression promoteFocusIndependentSubexpressions(ExpressionVisitor visitor,
                                                               ExpressionVisitor.ContextItemType contextItemType)
                                                        throws XPathException

  If any subexpressions within the step are not dependent on the focus, and if they are not "creative" expressions (expressions that can create new nodes), then promote them: this causes them to be evaluated once, outside the path expression

  Parameters:
    `visitor` - the expression visitor
    `contextItemType` - the type of the context item for evaluating the start expression
  Returns:
    the rewritten expression, or the original expression if no rewrite was possible
  Throws:
    `XPathException` - if a static error is detected

### promote

    public Expression promote(PromotionOffer offer,
                              Expression parent)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
    `parent` - the containing expression in the expression tree
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### iterateSameFocusSubExpressions

    public Iterator<Expression> iterateSameFocusSubExpressions()

  Get the immediate sub-expressions of this expression that are evaluated with the same focus (context item, position, and size) as the parent expression.

  Overrides:
    `iterateSameFocusSubExpressions` in class `Expression`
  Returns:
    an iterator containing those sub-expressions of this expression that are evaluated with the same focus as the parent expression

### hasLoopingSubexpression

    public boolean hasLoopingSubexpression(Expression child)

  Given an expression that is an immediate child of this expression, test whether the evaluation of the parent expression causes the child expression to be evaluated repeatedly

  Overrides:
    `hasLoopingSubexpression` in class `Expression`
  Parameters:
    `child` - the immediate subexpression
  Returns:
    true if the child expression is evaluated repeatedly

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### addToPathMap

    public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                               PathMap.PathMapNodeSet pathMapNodeSet)

  Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

  Overrides:
    `addToPathMap` in class `Expression`
  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodeSet` -
  Returns:
    the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression

### computeDependencies

    public int computeDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `computeDependencies` in class `Expression`
  Returns:
    the depencies, as a bit-mask

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    the special properties, as a bit-significant integer

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Specified by:
    `computeCardinality` in class `Expression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `Object`

### iterate

    public SequenceIterator<? extends Item> iterate(XPathContext context)
                                             throws XPathException

  Iterate the path-expression in a given context

  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### map

    public SequenceIterator map(XPathContext context)
                         throws XPathException

  Mapping function, from a node returned by the start iteration, to a sequence returned by the child.

  Specified by:
    `map` in interface `ContextMappingFunction<Item>`
  Parameters:
    `context` - The processing context. The item to be mapped is the context item identified from this context: the values of position() and last() also relate to the set of items being mapped
  Returns:
    a SequenceIterator over the sequence of items that the supplied input item maps to
  Throws:
    `XPathException` - if a dynamic error is detected

### explain

    public void explain(ExpressionPresenter destination)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `destination` - the expression presenter used to display the structure

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `Expression`
  Returns:
    a representation of the expression as a string

### getFirstStep

    public Expression getFirstStep()

  Get the first step in this expression. A path expression A/B/C is represented as (A/B)/C, but the first step is A

  Returns:
    the first step in the expression, after expanding any nested path expressions

### getStep

    public Expression getStep()

  Get step of the path expression

  Returns:
    the step expression

### getRemainingSteps

    public Expression getRemainingSteps()

  Get all steps after the first. This is complicated by the fact that A/B/C is represented as ((A/B)/C; we are required to return B/C

  Returns:
    a path expression containing all steps in this path expression other than the first, after expanding any nested path expressions

### getLastStep

    public Expression getLastStep()

  Get the last step of the path expression

  Returns:
    the last step in the expression, after expanding any nested path expressions

### getLeadingSteps

    public Expression getLeadingSteps()

  Get a path expression consisting of all steps except the last

  Returns:
    a path expression containing all steps in this path expression other than the last, after expanding any nested path expressions

### isAbsolute

    public boolean isAbsolute(TypeHierarchy th)

  Test whether a path expression is an absolute path - that is, a path whose first step selects a document node

  Parameters:
    `th` - the type hierarchy cache
  Returns:
    true if the first step in this path expression selects a document node

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.